from mpython import *
import time
import network
from umqtt.simple import MQTTClient
from machine import Timer
import machine
import ubinascii
import json
import math

my_wifi = wifi()

my_wifi.connectWiFi("mxy", "smj080823")

def OneNET_recv(_msg):pass
_OneNET_msg_list = []
def OneNET_callback(_topic, _msg):
    global _OneNET_msg_list
    try: _msg = _msg.decode('utf-8', 'ignore')
    except: print(_msg);return
    OneNET_recv(_msg)
    if _msg in _OneNET_msg_list:
        eval('OneNET_recv_' + bytes.decode(ubinascii.hexlify(_msg)) + '()')

tim14 = Timer(14)

def timer14_tick(_):
    global _dir
    if accelerometer.get_x() < -0.3:
        if 'F' != _dir:_dir = 'F';on_tilt_forward()
    elif accelerometer.get_x() > 0.3:
        if 'B' != _dir:_dir = 'B';on_tilt_back()
    elif accelerometer.get_y() < -0.3:
        if 'R' != _dir:_dir = 'R';on_tilt_right()
    elif accelerometer.get_y() > 0.3:
        if 'L' != _dir:_dir = 'L';on_tilt_left()
    else:
        if '' != _dir:_dir = '';on_tilt_none()

_iot = None
def OneNET_setup():
    global _iot
    _iot = MQTTClient("566544929", "183.230.40.39", 6002, "292081", "wVCSX14SwmBSuS=DIU2M=eHqVb0=", keepalive=300)
    _iot.set_callback(OneNET_callback)
    if 1 == _iot.connect(): print('Successfully connected to MQTT server.')
    tim14.init(period=200, mode=Timer.PERIODIC, callback=timer14_tick)

def on_button_b_down(_):
    time.sleep_ms(10)
    if button_b.value() == 1: return
    tim14.deinit()
    _iot.disconnect()
    print('Disconnected from MQTT server.')
    rgb[0] = (int(255/30), int(204/30), int(0/30))
    rgb.write()
    time.sleep_ms(1)

def pubdata(_dic):
    print(_dic)
    _list = []
    for _key in list(_dic.keys()):
        _d = {'id':_key,'datapoints':[{'value':_dic[_key]}]}
        _list.append(_d)
    _data = {'datastreams': _list}
    j_d = json.dumps(_data)
    j_l = len(j_d)
    arr = bytearray(j_l + 3)
    arr[0] = 1
    arr[1] = int(j_l / 256)
    arr[2] = j_l % 256
    arr[3:] = j_d.encode('ascii')
    return arr

def on_button_a_down(_):
    time.sleep_ms(10)
    if button_a.value() == 1: return
    _iot.publish('$dp', pubdata({"yuntian":get_tilt_angle('X')}))
    rgb[0] = (int(255/30), int(0/30), int(0/30))
    rgb.write()
    time.sleep_ms(1)
    time.sleep(2)
    rgb[0] = (int(0/30), int(0/30), int(0/30))
    rgb.write()
    time.sleep_ms(1)

_dir = ''
def on_tilt_forward():pass
def on_tilt_back():pass
def on_tilt_right():pass
def on_tilt_left():pass
def on_tilt_none():pass

tim14.init(period=200, mode=Timer.PERIODIC, callback=timer14_tick)

def on_tilt_left():
    oled.fill(0)
    oled.DispChar((str(get_tilt_angle('X'))), 0, 0, 1)
    oled.show()

def OneNET_recv(_msg):
    oled.fill(0)
    oled.DispChar(_msg, 0, 0, 1)
    oled.show()

_OneNET_msg_list.append('开灯')
def OneNET_recv_e5bc80e781af():
    rgb[1] = (int(255/30), int(0/30), int(0/30))
    rgb.write()
    time.sleep_ms(1)
    rgb[2] = (int(0/30), int(0/30), int(0/30))
    rgb.write()
    time.sleep_ms(1)
    oled.DispChar("开灯", 0, 0, 1)

_OneNET_msg_list.append('关灯')
def OneNET_recv_e585b3e781af():
    rgb[1] = (int(0/30), int(0/30), int(0/30))
    rgb.write()
    time.sleep_ms(1)
    rgb[2] = (int(255/30), int(0/30), int(0/30))
    rgb.write()
    time.sleep_ms(1)
    oled.DispChar("关灯", 0, 0, 1)

button_b.irq(trigger=Pin.IRQ_FALLING, handler=on_button_b_down)

def get_tilt_angle(_axis):
    _Ax = accelerometer.get_x()
    _Ay = accelerometer.get_y()
    _Az = accelerometer.get_z()
    if 'X' == _axis:
        _T = math.sqrt(_Ay ** 2 + _Az ** 2)
        if _Az < 0: return math.degrees(math.atan2(_Ax , _T))
        else: return 180 - math.degrees(math.atan2(_Ax , _T))
    elif 'Y' == _axis:
        _T = math.sqrt(_Ax ** 2 + _Az ** 2)
        if _Az < 0: return math.degrees(math.atan2(_Ay , _T))
        else: return 180 - math.degrees(math.atan2(_Ay , _T))
    elif 'Z' == _axis:
        _T = math.sqrt(_Ax ** 2 + _Ay ** 2)
        if (_Ax + _Ay) < 0: return 180 - math.degrees(math.atan2(_T , _Az))
        else: return math.degrees(math.atan2(_T , _Az)) - 180
    return 0

button_a.irq(trigger=Pin.IRQ_FALLING, handler=on_button_a_down)


rgb.fill( (0, 0, 0) )
rgb.write()
time.sleep_ms(1)
while not my_wifi.sta.isconnected():
    pass
oled.fill(0)
oled.DispChar("Wifi_OK", 0, 0, 1)
oled.show()
OneNET_setup()
oled.fill(0)
oled.DispChar("OneNet_OK", 0, 0, 1)
oled.show()
